var DEFAULT_NAME = 'map.png';	
	
var exposed = null;	
var file = null;
var map_rect = null;

function encodeImage()	
{
	var bmp = new air.BitmapData( map_rect.width - 2, map_rect.height - 2 );
	var png = null;
	var stream = new air.FileStream();
	var matrix = new air.Matrix();
	
	matrix.translate( 0 - ( map_rect.x + 1 ), 0 - ( map_rect.y + 1 ) );	
	bmp.draw( window.htmlLoader, matrix );
	
	png = runtime.com.adobe.images.PNGEncoder.encode( bmp );
	
	stream.open( file, air.FileMode.WRITE );
	stream.writeBytes( png, 0, 0 );
	stream.close();	
}

function setMapRect( rect )
{
	map_rect = new air.Rectangle( rect.x, rect.y, rect.width, rect.height );	
}

function doCopyClick( rect )
{
	setMapRect( rect );
	
	file = air.File.applicationStorageDirectory.resolvePath( DEFAULT_NAME );

	encodeImage();
	
	air.Clipboard.generalClipboard.setData( air.ClipboardFormats.FILE_LIST_FORMAT, new runtime.Array( file )  );
	
	alert( 'Your map is now on the clipboard!' );
}

function doDragMove( rect )
{
	var clipboard = new air.Clipboard();
	var crop = null;
	var scale = null;	
	var png = null;
	var stream = new air.FileStream();
	var matrix = null;
	var ratio = 0;

	// Store offsets
	setMapRect( rect );
	
	// Get the cropped pixels from the display list
	crop = new air.BitmapData( map_rect.width - 2, map_rect.height - 2 );

	// Get bitmap of map only
	matrix = new air.Matrix();	
	matrix.translate( 0 - ( map_rect.x + 1 ), 0 - ( map_rect.y + 1 ) );		
	crop.draw( window.htmlLoader, matrix );	

	// Generate thumbnail
	ratio = 160 / crop.width;
	matrix.scale( ratio, ratio );

	scale = new air.BitmapData( crop.width * ratio, crop.height * ratio );
	scale.draw( window.htmlLoader, matrix );

	// Encode to disk
	// Creates new reference
	file = air.File.applicationStorageDirectory.resolvePath( DEFAULT_NAME );

	png = runtime.com.adobe.images.PNGEncoder.encode( crop );

	stream.open( file, air.FileMode.WRITE );
	stream.writeBytes( png, 0, 0 );
	stream.close();			

	// Put data on clipboard and start native drag operation
	clipboard.setData( air.ClipboardFormats.FILE_LIST_FORMAT, new runtime.Array( file )  );
	air.NativeDragManager.doDrag( window.htmlLoader, clipboard, scale, new air.Point( 0 - ( scale.width / 2 ), 0 - ( scale.height / 2 ) ) );
}
	
function doLoad()
{
	var exposed = new Object();
	
	exposed.doSaveClick = doSaveClick;
	exposed.doCopyClick = doCopyClick;	
	exposed.doDragMove = doDragMove;		
	
	document.getElementById( 'viewport' ).contentWindow.parentSandboxBridge = exposed;

	file = air.File.desktopDirectory.resolvePath( DEFAULT_NAME );	
}	

function doSaveClick( rect )
{
	setMapRect( rect )
	
	file.addEventListener( air.Event.SELECT, doSaveSelect );
	file.browseForSave( 'Where would you like to save your map?' );	
}

function doSaveSelect()
{
	encodeImage();
	
	alert( 'Your map has been saved!' );
}