var DEFAULT_TEXT = 'Address, City, State';
var HOME_GEO = 'Denver, CO';

var map = null;

function getMapRect()
{
	var dim = Element.getDimensions( $( 'mapholder' ) );
	var pos = Position.cumulativeOffset( $( 'mapholder' ) );	
	var rect = new Object();
	
	rect.x = pos[0];
	rect.y = pos[1];
	rect.width = dim.width;
	rect.height = dim.height;
	
	return rect;	
}

function doCopyClick()
{
	parentSandboxBridge.doCopyClick( getMapRect() );
}

function doDragDown()
{
	this.src = 'images/' + this.id + '-down.gif';
	this.addEventListener( 'mousemove', doDragMove );	
}

function doDragMove( e )
{
	// Kill events and reset UI
	e.stopPropagation();
	this.removeEventListener( 'mousemove', doDragMove );
	this.src = 'images/' + this.id + '-up.gif';

	// Manage image persistance and native drag and drop operation
	parentSandboxBridge.doDragMove( getMapRect() );
}

function doDragOut()
{
	this.src = 'images/' + this.id + '-up.gif';
	this.removeEventListener( 'mousemove', doDragMove );
}

function doDragOver()
{
	this.src = 'images/' + this.id + '-over.gif';
}

function doDragUp()
{
	this.src = 'images/' + this.id + '-over.gif';
	this.removeEventListener( 'mousemove', doDragMove );
}

function doGoClick()
{
	var geo = document.getElementById( 'location' ).value;
	
	if( geo != DEFAULT_TEXT )
	{
		map.drawZoomAndCenter( geo );		
	}
}

function doLoad()
{
	document.getElementById( 'location' ).addEventListener( 'blur', doLocationBlur );
	document.getElementById( 'location' ).addEventListener( 'focus', doLocationFocus );	
	
	document.getElementById( 'go' ).addEventListener( 'mouseover', doSwapOver );	
	document.getElementById( 'go' ).addEventListener( 'mousedown', doSwapDown );		
	document.getElementById( 'go' ).addEventListener( 'mouseup', doSwapUp );		
	document.getElementById( 'go' ).addEventListener( 'mouseout', doSwapOut );		
	document.getElementById( 'go' ).addEventListener( 'click', doGoClick );			
	
	document.getElementById( 'save' ).addEventListener( 'mouseover', doSwapOver );	
	document.getElementById( 'save' ).addEventListener( 'mousedown', doSwapDown );		
	document.getElementById( 'save' ).addEventListener( 'mouseup', doSwapUp );		
	document.getElementById( 'save' ).addEventListener( 'mouseout', doSwapOut );		
	document.getElementById( 'save' ).addEventListener( 'click', doSaveClick );				
	
	document.getElementById( 'copy' ).addEventListener( 'mouseover', doSwapOver );	
	document.getElementById( 'copy' ).addEventListener( 'mousedown', doSwapDown );		
	document.getElementById( 'copy' ).addEventListener( 'mouseup', doSwapUp );		
	document.getElementById( 'copy' ).addEventListener( 'mouseout', doSwapOut );		
	document.getElementById( 'copy' ).addEventListener( 'click', doCopyClick );					
	
	document.getElementById( 'drag' ).addEventListener( 'mouseover', doDragOver );	
	document.getElementById( 'drag' ).addEventListener( 'mousedown', doDragDown );		
	document.getElementById( 'drag' ).addEventListener( 'mouseup', doDragUp );		
	document.getElementById( 'drag' ).addEventListener( 'mouseout', doDragOut );		

	map = new YMap( document.getElementById( 'map' ) );
	map.addTypeControl();
	map.addPanControl();
	map.addZoomShort();
	map.drawZoomAndCenter( HOME_GEO, 8 );		
}

function doLocationBlur()
{
	if( this.value.length == 0 )
	{
		this.style.color = '#666666';
		this.value = DEFAULT_TEXT;
	}
	
	document.getElementById( 'outer' ).style.visibility = 'hidden';
	document.getElementById( 'inner' ).style.visibility = 'hidden';		
}

function doLocationFocus()
{
	if( this.value == DEFAULT_TEXT )
	{
		this.value = '';
		this.style.color = '#000000';
	}
	
	document.getElementById( 'outer' ).style.visibility = 'visible';
	document.getElementById( 'inner' ).style.visibility = 'visible';	
}

function doSaveClick()
{
	parentSandboxBridge.doSaveClick( getMapRect() );
}

function doSwapDown()
{
	this.src = 'images/' + this.id + '-down.gif';
}

function doSwapOut()
{
	this.src = 'images/' + this.id + '-up.gif';
}

function doSwapOver()
{
	this.src = 'images/' + this.id + '-over.gif';
}

function doSwapUp()
{
	this.src = 'images/' + this.id + '-over.gif';
}